Index: /palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_v.f90	(revision 1319)
+++ /palm/trunk/SOURCE/diffusion_v.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -46,31 +52,4 @@
 ! outflow damping layer removed
 ! kmxm_x/_y and kmxp_x/_y change to kmxm and kmxp
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 366 2009-08-25 08:06:27Z raasch
-! bc_lr replaced by bc_lr_cyc
-!
-! 106 2007-08-16 14:30:26Z raasch
-! Momentumflux at top (vswst) included as boundary condition,
-! j loop is starting from nysv (needed for non-cyclic boundary conditions)
-!
-! 75 2007-03-22 09:54:05Z raasch
-! Wall functions now include diabatic conditions, call of routine wall_fluxes,
-! z0 removed from argument list, vynp eliminated
-!
-! 20 2007-02-26 00:12:32Z raasch
-! Bugfix: ddzw dimensioned 1:nzt"+1"
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.15  2006/02/23 10:36:00  raasch
-! nzb_2d replaced by nzb_v_outer in horizontal diffusion and by nzb_v_inner
-! or nzb_diff_v, respectively, in vertical diffusion,
-! wall functions added for north and south walls, +z0 in argument list,
-! terms containing w(k-1,..) are removed from the Prandtl-layer equation
-! because they cause errors at the edges of topography
-! WARNING: loops containing the MAX function are still not properly vectorized!
 !
 ! Revision 1.1  1997/09/12 06:24:01  raasch
@@ -105,15 +84,31 @@
     SUBROUTINE diffusion_v
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w
+       
+       USE control_parameters,                                                 &
+           ONLY:  constant_top_momentumflux, topography, use_surface_fluxes,   &
+                  use_top_fluxes
+       
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy, ddy2, fxm, fxp, wall_v
+       
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nysv, nzb, nzb_diff_v, nzb_v_inner,      &
+                  nzb_v_outer, nzt, nzt_diff
+       
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-       REAL    ::  kmxm, kmxp, kmzm, kmzp
-
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  vsus
+       INTEGER(iwp) ::  i     !: 
+       INTEGER(iwp) ::  j     !: 
+       INTEGER(iwp) ::  k     !: 
+       REAL(wp)     ::  kmxm  !: 
+       REAL(wp)     ::  kmxp  !: 
+       REAL(wp)     ::  kmzm  !: 
+       REAL(wp)     ::  kmzp  !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  vsus  !: 
 
 !
@@ -121,5 +116,5 @@
 !--    if neccessary
        IF ( topography /= 'flat' )  THEN
-          CALL wall_fluxes( vsus, 0.0, 1.0, 0.0, 0.0, nzb_v_inner, &
+          CALL wall_fluxes( vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, nzb_v_inner, &
                             nzb_v_outer, wall_v )
        ENDIF
@@ -137,13 +132,13 @@
                        ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
-                tend(k,j,i) = tend(k,j,i)                                    &
-                      & + ( kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx       &
-                      &   + kmxp * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy       &
-                      &   - kmxm * ( v(k,j,i) - v(k,j,i-1) ) * ddx           &
-                      &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy           &
-                      &   ) * ddx                                            &
-                      & + 2.0 * (                                            &
-                      &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )    &
-                      &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )    &
+                tend(k,j,i) = tend(k,j,i)                                      &
+                      & + ( kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx         &
+                      &   + kmxp * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy         &
+                      &   - kmxm * ( v(k,j,i) - v(k,j,i-1) ) * ddx             &
+                      &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
+                      &   ) * ddx                                              &
+                      & + 2.0 * (                                              &
+                      &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )      &
+                      &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )      &
                       &         ) * ddy2
              ENDDO
@@ -154,7 +149,7 @@
 
                 DO  k = nzb_v_inner(j,i)+1, nzb_v_outer(j,i)
-                   kmxp = 0.25 * &
+                   kmxp = 0.25 *                                               &
                           ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                   kmxm = 0.25 * &
+                   kmxm = 0.25 *                                               &
                           ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
                    
@@ -188,11 +183,11 @@
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-                tend(k,j,i) = tend(k,j,i)                                    &
-                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)   &
-                      &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy         &
-                      &            )                                         &
-                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k) &
-                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy     &
-                      &            )                                         &
+                tend(k,j,i) = tend(k,j,i)                                      &
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)     &
+                      &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy           &
+                      &            )                                           &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
+                      &            )                                           &
                       &   ) * ddzw(k)
              ENDDO
@@ -204,5 +199,5 @@
 !--          Difference quotient of the momentum flux is not formed over
 !--          half of the grid spacing (2.0*ddzw(k)) any more, since the
-!--          comparison with other (LES) modell showed that the values of
+!--          comparison with other (LES) models showed that the values of
 !--          the momentum flux becomes too large in this case.
 !--          The term containing w(k-1,..) (see above equation) is removed here
@@ -212,14 +207,14 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 * &
+                kmzp = 0.25 *                                                  &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 * &
+                kmzm = 0.25 *                                                  &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-                tend(k,j,i) = tend(k,j,i)                                    &
-                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy       &
-                      &   ) * ddzw(k)                                        &
-                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1) &
-                      &   + vsws(j,i)                                        &
+                tend(k,j,i) = tend(k,j,i)                                      &
+                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy         &
+                      &   ) * ddzw(k)                                          &
+                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1)   &
+                      &   + vsws(j,i)                                          &
                       &   ) * ddzw(k)
              ENDIF
@@ -232,14 +227,14 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 * &
+                kmzp = 0.25 *                                                  &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 * &
+                kmzm = 0.25 *                                                  &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-                tend(k,j,i) = tend(k,j,i)                                    &
-                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy      &
-                      &   ) * ddzw(k)                                        &
-                      & + ( -vswst(j,i)                                      &
-                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)  &
+                tend(k,j,i) = tend(k,j,i)                                      &
+                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy        &
+                      &   ) * ddzw(k)                                          &
+                      & + ( -vswst(j,i)                                        &
+                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)    &
                       &   ) * ddzw(k)
              ENDIF
@@ -256,15 +251,31 @@
     SUBROUTINE diffusion_v_acc
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w
+       
+       USE control_parameters,                                                 &
+           ONLY:  constant_top_momentumflux, topography, use_surface_fluxes,   &
+                  use_top_fluxes
+       
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy, ddy2, fxm, fxp, wall_v
+       
+       USE indices,                                                            &
+           ONLY:  i_left, i_right, j_north, j_south, nxl, nxr, nyn, nys, nzb,  &
+                  nzb_diff_v, nzb_v_inner, nzb_v_outer, nzt, nzt_diff
+       
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-       REAL    ::  kmxm, kmxp, kmzm, kmzp
-
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  vsus
+       INTEGER(iwp) ::  i     !: 
+       INTEGER(iwp) ::  j     !: 
+       INTEGER(iwp) ::  k     !: 
+       REAL(wp)     ::  kmxm  !: 
+       REAL(wp)     ::  kmxp  !: 
+       REAL(wp)     ::  kmzm  !: 
+       REAL(wp)     ::  kmzp  !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  vsus  !: 
        !$acc declare create ( vsus )
 
@@ -273,10 +284,10 @@
 !--    if neccessary
        IF ( topography /= 'flat' )  THEN
-          CALL wall_fluxes_acc( vsus, 0.0, 1.0, 0.0, 0.0, nzb_v_inner, &
-                                nzb_v_outer, wall_v )
-       ENDIF
-
-       !$acc kernels present ( u, v, w, km, tend, vsws, vswst )   &
-       !$acc         present ( ddzu, ddzw, fxm, fxp, wall_v )           &
+          CALL wall_fluxes_acc( vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp,          &
+                                nzb_v_inner, nzb_v_outer, wall_v )
+       ENDIF
+
+       !$acc kernels present ( u, v, w, km, tend, vsws, vswst )                &
+       !$acc         present ( ddzu, ddzw, fxm, fxp, wall_v )                  &
        !$acc         present ( nzb_v_inner, nzb_v_outer, nzb_diff_v )
        DO  i = i_left, i_right
@@ -288,7 +299,7 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmxp = 0.25 * &
+                   kmxp = 0.25 *                                               &
                           ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                   kmxm = 0.25 * &
+                   kmxm = 0.25 *                                               &
                           ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
@@ -309,10 +320,10 @@
 !--          Wall functions at the left and right walls, respectively
              DO  k = 1, nzt
-                IF( k > nzb_v_inner(j,i)  .AND.  k <= nzb_v_outer(j,i)  .AND. &
+                IF( k > nzb_v_inner(j,i)  .AND.  k <= nzb_v_outer(j,i)  .AND.  &
                     wall_v(j,i) /= 0.0 )  THEN
 
-                   kmxp = 0.25 * &
+                   kmxp = 0.25 *                                               &
                           ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-                   kmxm = 0.25 * &
+                   kmxm = 0.25 *                                               &
                           ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
                    
@@ -342,7 +353,7 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmzp = 0.25 * &
+                   kmzp = 0.25 *                                               &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                   kmzm = 0.25 * &
+                   kmzm = 0.25 *                                               &
                           ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
@@ -367,5 +378,5 @@
 !--    Difference quotient of the momentum flux is not formed over
 !--    half of the grid spacing (2.0*ddzw(k)) any more, since the
-!--    comparison with other (LES) modell showed that the values of
+!--    comparison with other (LES) models showed that the values of
 !--    the momentum flux becomes too large in this case.
 !--    The term containing w(k-1,..) (see above equation) is removed here
@@ -379,14 +390,14 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 * &
+                kmzp = 0.25 *                                                  &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 * &
+                kmzm = 0.25 *                                                  &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-                tend(k,j,i) = tend(k,j,i)                                    &
-                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy       &
-                      &   ) * ddzw(k)                                        &
-                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1) &
-                      &   + vsws(j,i)                                        &
+                tend(k,j,i) = tend(k,j,i)                                      &
+                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy         &
+                      &   ) * ddzw(k)                                          &
+                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1)   &
+                      &   + vsws(j,i)                                          &
                       &   ) * ddzw(k)
              ENDDO
@@ -407,14 +418,14 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25 * &
+                kmzp = 0.25 *                                                  &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-                kmzm = 0.25 * &
+                kmzm = 0.25 *                                                  &
                        ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-                tend(k,j,i) = tend(k,j,i)                                    &
-                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy      &
-                      &   ) * ddzw(k)                                        &
-                      & + ( -vswst(j,i)                                      &
-                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)  &
+                tend(k,j,i) = tend(k,j,i)                                      &
+                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy        &
+                      &   ) * ddzw(k)                                          &
+                      & + ( -vswst(j,i)                                        &
+                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)    &
                       &   ) * ddzw(k)
              ENDDO
@@ -432,15 +443,29 @@
     SUBROUTINE diffusion_v_ij( i, j )
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w
+       
+       USE control_parameters,                                                 &
+           ONLY:  constant_top_momentumflux, use_surface_fluxes, use_top_fluxes
+       
+       USE grid_variables,                                                     &
+           ONLY:  ddx, ddy, ddy2, fxm, fxp, wall_v
+       
+       USE indices,                                                            &
+           ONLY:  nzb, nzb_diff_v, nzb_v_inner, nzb_v_outer, nzt, nzt_diff
+       
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-       REAL    ::  kmxm, kmxp, kmzm, kmzp
-
-       REAL, DIMENSION(nzb:nzt+1) ::  vsus
+       INTEGER(iwp) ::  i     !: 
+       INTEGER(iwp) ::  j     !: 
+       INTEGER(iwp) ::  k     !: 
+       REAL(wp)     ::  kmxm  !: 
+       REAL(wp)     ::  kmxp  !: 
+       REAL(wp)     ::  kmzm  !: 
+       REAL(wp)     ::  kmzp  !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  vsus  !: 
 
 !
@@ -452,13 +477,13 @@
           kmxm = 0.25 * ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
-          tend(k,j,i) = tend(k,j,i)                                          &
-                      & + ( kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx       &
-                      &   + kmxp * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy       &
-                      &   - kmxm * ( v(k,j,i) - v(k,j,i-1) ) * ddx           &
-                      &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy           &
-                      &   ) * ddx                                            &
-                      & + 2.0 * (                                            &
-                      &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )    &
-                      &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )    &
+          tend(k,j,i) = tend(k,j,i)                                            &
+                      & + ( kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx         &
+                      &   + kmxp * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy         &
+                      &   - kmxm * ( v(k,j,i) - v(k,j,i-1) ) * ddx             &
+                      &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
+                      &   ) * ddx                                              &
+                      & + 2.0 * (                                              &
+                      &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )      &
+                      &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )      &
                       &         ) * ddy2
        ENDDO
@@ -470,11 +495,11 @@
 !
 !--       Calculate the horizontal momentum flux v'u'
-          CALL wall_fluxes( i, j, nzb_v_inner(j,i)+1, nzb_v_outer(j,i), &
-                            vsus, 0.0, 1.0, 0.0, 0.0 )
+          CALL wall_fluxes( i, j, nzb_v_inner(j,i)+1, nzb_v_outer(j,i),        &
+                            vsus, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp )
 
           DO  k = nzb_v_inner(j,i)+1, nzb_v_outer(j,i)
-             kmxp = 0.25 * &
+             kmxp = 0.25 *                                                     &
                     ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-             kmxm = 0.25 * &
+             kmxm = 0.25 *                                                     &
                     ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
 
@@ -506,11 +531,11 @@
           kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-          tend(k,j,i) = tend(k,j,i)                                          &
-                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)   &
-                      &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy         &
-                      &            )                                         &
-                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k) &
-                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy     &
-                      &            )                                         &
+          tend(k,j,i) = tend(k,j,i)                                            &
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)     &
+                      &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy           &
+                      &            )                                           &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
+                      &            )                                           &
                       &   ) * ddzw(k)
        ENDDO
@@ -522,5 +547,5 @@
 !--    Difference quotient of the momentum flux is not formed over half of
 !--    the grid spacing (2.0*ddzw(k)) any more, since the comparison with 
-!--    other (LES) modell showed that the values of the momentum flux becomes
+!--    other (LES) models showed that the values of the momentum flux becomes
 !--    too large in this case.
 !--    The term containing w(k-1,..) (see above equation) is removed here
@@ -533,9 +558,9 @@
           kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-          tend(k,j,i) = tend(k,j,i)                                          &
-                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy       &
-                      &   ) * ddzw(k)                                        &
-                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1) &
-                      &   + vsws(j,i)                                        &
+          tend(k,j,i) = tend(k,j,i)                                            &
+                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy         &
+                      &   ) * ddzw(k)                                          &
+                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1)   &
+                      &   + vsws(j,i)                                          &
                       &   ) * ddzw(k)
        ENDIF
@@ -553,9 +578,9 @@
                  ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
-          tend(k,j,i) = tend(k,j,i)                                          &
-                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy      &
-                      &   ) * ddzw(k)                                        &
-                      & + ( -vswst(j,i)                                      &
-                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)  &
+          tend(k,j,i) = tend(k,j,i)                                            &
+                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy        &
+                      &   ) * ddzw(k)                                          &
+                      & + ( -vswst(j,i)                                        &
+                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)    &
                       &   ) * ddzw(k)
        ENDIF
